<?php
/**
 * ShopEx licence
 *
 * @copyright  Copyright (c) 2005-2012 ShopEx Technologies Inc. (http://www.shopex.cn)
 * @license  http://ecos.shopex.cn/ ShopEx License
 */


class system_prism_notify {

    static private $__conn = array();

    public function setTopic($topic)
    {
        $this->topic = $topic;
        return $this;
    }

    public function conn($shopId)
    {
        if( self::$__conn[$this->topic] )
        {
            return self::$__conn[$this->topic];
        }
        else
        {
            $this->__get_connection($shopId);
        }

        return $this;
    }

    public function write($data)
    {
        $notifyMessage = json_encode($data);

        $res = self::$__conn[$this->topic]->post('/platform/notify/write', array('topic'=>$this->topic, 'data'=>$notifyMessage));
        return $res['result'];
    }

    /**
     * 配置消息路由
     */
    public function publish()
    {
        $conn = system_prism_init_util::getAdminConn();

        $appId = 'openstandard';
        $primsAppId = system_prism_init_util::getAppId($appId);
        $params['app_id'] = $primsAppId;

        $routing = config::get('prism.routing');
        $params['routing_key'] = json_encode(array_values($routing));
        logger::info('params : queue publish '.var_export($params));

        return kernel::single('system_prism_init_base')->call( $conn, '/api/platform/manageapp/queue/publish', $params, 'post' );
    }

    /**
     * 配置可消费消息路由
     */
    public function consume()
    {
        $conn = system_prism_init_util::getAdminConn();

        $appId = 'openstandard';
        $primsAppId = system_prism_init_util::getAppId($appId);
        $params['app_id'] = $primsAppId;

        $routing = config::get('prism.routing');
        $params['routing_key'] = json_encode(array_values($routing));

        logger::info('params : queue consume '.var_export($params));
        return kernel::single('system_prism_init_base')->call( $conn, '/api/platform/manageapp/queue/consume', $params, 'post' );
    }

    public function setRouting($topic, $routingKey)
    {
        $res = self::$__conn[$this->topic]->post('/platform/notify/routing/set', array('topic'=>$topic, 'routing_key'=>$routingKey));
        return $res['result'];
    }

    private function __get_connection($shopId)
    {
        $keySecret = kernel::single('sysopen_shop_info')->getShopOpenInfo($shopId);
        $key = $keySecret['key'];
        $secret = $keySecret['secret'];

        $host = config::get('prism.prismHostUrl');
        $host = rtrim($host, '/') . '/api';

        //这个是长连接的配置
        $socketFile = config::get('prism.prismSocketFile');

        //创建队列传输链接
        self::$__conn[$this->topic] = new base_prism_client($host, $key, $secret, $socketFile);

        return self::$__conn[$this->topic];
    }
}

